<?php
	global $arf_digital_product, $arf_dig_pro_products_class;
?>

<div class="wrap digi_page">
	<div class="top_bar">
	 <span class="h2">
		<?php if ( isset( $_GET['arfaction'] ) && $_GET['arfaction'] == 'new' ) { ?>
			<?php esc_html_e( 'Add New Product', 'ARForms-Digital-Product' ); ?></span>
			<?php
		} elseif ( isset( $_GET['arfaction'] ) && $_GET['arfaction'] == 'edit' ) {
			?>
			<?php esc_html_e( 'Edit Product', 'ARForms-Digital-Product' ); ?></span>
		<?php } ?>
	</div>
	<div id="poststuff" class="metabox-holder">
		<div id="post-body">
			<div class="inside">

				<div class="arf_success_message" id="success_message">
					<div class="message_descripiton">
						<div class="success_msg_text arf_digpro_success_msg_text" id="success_msg_text" ></div>
						<div class="message_svg_icon">
							<svg stroke-width="14px" height="14px">
								<path fill-rule="evenodd" clip-rule="evenodd" fill="#FFFFFF" d="M6.075,14.407l-5.852-5.84l1.616-1.613l4.394,4.385L17.181,0.411 l1.616,1.613L6.392,14.407H6.075z"></path>
							</svg>
						</div>
					</div>
				</div>

				<div id="error_message" class="arf_error_message">
					<div class="message_descripiton">
						<div class="error_msg_text arf_digpro_error_msg_text" id="error_msg_text"></div>
						<div class="message_svg_icon">
							<svg stroke-width="14px" height="14px">
								<path fill-rule="evenodd" clip-rule="evenodd" fill="#ffffff" d="M10.702,10.909L6.453,6.66l-4.249,4.249L1.143,9.848l4.249-4.249L1.154,1.361l1.062-1.061l4.237,4.237l4.238-4.237l1.061,1.061L7.513,5.599l4.249,4.249L10.702,10.909z"></path>
							</svg>
						</div>
					</div>
				</div>


				<div class="frm_settings_form wrap_content">
					<?php

					$product_id = ( isset( $_REQUEST['id'] ) && ! empty( $_REQUEST['id'] ) ) ? $_REQUEST['id'] : '';

					if ( $arfaction == '' ) {
						$arfaction = $_REQUEST['arfaction'];
					}

					$nonce_field = wp_create_nonce( 'arf_digital_product' );
					?>
					<input type="hidden" id="arf_digital_product_nonce" name="_wpnonce_arf_digital_product" value="<?php echo esc_html( $nonce_field ); ?>" />
					<input type="hidden" id="arf_older_version" value="false" />
					<form name="arf_dig_pro_setting" id="arf_dig_pro_setting" method="post" onSubmit="return arf_dig_pro_save();" enctype="multipart/form-data">
						<input type="hidden" id="arf_ajaxurl" value="<?php echo esc_url( admin_url( 'admin-ajax.php' ) ); ?>" />
						<input type="hidden" id="arfaction" name="arfaction" value="<?php echo esc_html($arfaction); ?>">
						<table class="form-table">
							<tbody id="arf_dig_pro_setting_table">
								<tr class="tdclass">
									<td width="18%" class="tdclass" valign="top">
										<label class="lblsubtitle"><?php esc_html_e( 'Product Name', 'ARForms-Digital-Product' ); ?>&nbsp;<span class="arfglobalrequiredfield arf_digpro_valign_top">*</span>
										</label>
									</td>
									<td>
										<input type="text" name="arf_product_name" id="arf_product_name" value="<?php echo esc_attr( $values['arf_product_name'] ); ?>" class="txtstandardnew txtmodal1 arf_digpro_input_width" />
										<div class="arferrmessage" id="arf_product_name_msg arf_display_none">
											<?php esc_html_e( 'This field cannot be blank.', 'ARForms-Digital-Product' ); ?>
										</div>
									</td>
								</tr>
								<tr class="tdclass success_action_message_box success_action_box">
									<td class="tdclass arf_digpro_valign_top" valign="top">
										<label class="lblsubtitle arf_digpro_valign_top">
											<?php esc_html_e( 'Description', 'ARForms-Digital-Product' ); ?>
										</label>
									</td>
									<td>
										<textarea id="success_msg" name="arf_product_description" cols="50" rows="4" class="arfplacelonginput txtmultinew txtmodal1 arf_digpro_input_width"><?php echo stripslashes( esc_attr( $values['arf_product_description'] ) ); ?></textarea>
									<td>
								</tr>
								<tr class="tdclass">
									<td valign="top" class="tdclass"><label class="lblsubtitle">
											<?php esc_html_e( 'Product Status', 'ARForms-Digital-Product' ); ?>
										</label></td>
									<td>
										<div class="arf_radio_wrapper">
											<div class="arf_custom_radio_div">
												<div class="arf_custom_radio_wrapper">
													<input type="radio" class="arf_custom_radio" id="arf_product_enable_status" name="arf_product_status" value="1" <?php checked( $values['arf_product_status'], 1 ); ?>>
													<svg width="18px" height="18px">
														<?php echo ARF_CUSTOM_UNCHECKEDRADIO_ICON; ?>
														<?php echo ARF_CUSTOM_CHECKEDRADIO_ICON; ?>
													</svg>
												</div>
											</div>
											<span>
												<label for="arf_product_enable_status"><?php esc_html_e( 'Enable', 'ARForms-Digital-Product' ); ?></label>
											</span>
										</div>
										<div class="arf_radio_wrapper">
											<div class="arf_custom_radio_div">
												<div class="arf_custom_radio_wrapper">
													<input type="radio" class="arf_custom_radio" id="arf_product_disable_status" name="arf_product_status" value="0" <?php checked( $values['arf_product_status'], 0 ); ?> />
													<svg width="18px" height="18px">
														<?php echo ARF_CUSTOM_UNCHECKEDRADIO_ICON; ?>
														<?php echo ARF_CUSTOM_CHECKEDRADIO_ICON; ?>
													</svg>
												</div>
											</div>
											<span>
												<label for="arf_product_disable_status"><?php esc_html_e( 'Disable', 'ARForms-Digital-Product' ); ?></label>
											</span>
										</div>
									</td>
								</tr>
								<tr>
									<td colspan="2">&nbsp;</td>
								</tr>
								<tr class="tdclass">
									<td valign="top" colspan="2" class="lbltitle titleclass"><br /><?php esc_html_e( 'Download', 'ARForms-Digital-Product' ); ?></td>
								</tr>
								<tr class="tdclass">
									<td valign="top" class="tdclass arf_digpro_valign_top" >
										<label class="lblsubtitle"><?php esc_html_e( 'Download Type', 'ARForms-Digital-Product' ); ?></label>
									</td>
									<td>
										<div class="arf_radio_wrapper">
											<div class="arf_custom_radio_div">
												<div class="arf_custom_radio_wrapper">
													<input type="radio" class="arf_custom_radio" id="arf_dig_pro_internal_type" name="arf_dig_pro_download_type" value="internal"  <?php checked( $values['arf_dig_pro_download_type'], 'internal' ); ?> />
													<svg width="18px" height="18px">
														<?php echo ARF_CUSTOM_UNCHECKEDRADIO_ICON; ?>
														<?php echo ARF_CUSTOM_CHECKEDRADIO_ICON; ?>
													</svg>
												</div>
											</div>
											<span>
												<label for="arf_dig_pro_internal_type"><?php esc_html_e( 'Internal', 'ARForms-Digital-Product' ); ?></label>
											</span>
										</div>
										<div class="arf_radio_wrapper">
											<div class="arf_custom_radio_div">
												<div class="arf_custom_radio_wrapper">
													<input type="radio" class="arf_custom_radio" id="arf_dig_pro_external_type" name="arf_dig_pro_download_type" value="external" <?php checked( $values['arf_dig_pro_download_type'], 'external' ); ?>>
													<svg width="18px" height="18px">
														<?php echo ARF_CUSTOM_UNCHECKEDRADIO_ICON; ?>
														<?php echo ARF_CUSTOM_CHECKEDRADIO_ICON; ?>
													</svg>
												</div>
											</div>
											<span>
												<label for="arf_dig_pro_external_type"><?php esc_html_e( 'External', 'ARForms-Digital-Product' ); ?></label>
											</span>
										</div>
									</td>
								</tr>

								<tr class="tdclass arf_dig_pro_external_type_data">
									<td width="18%" class="tdclass" valign="top">
										<label class="lblsubtitle"><?php esc_html_e( 'Download Url', 'ARForms-Digital-Product' ); ?></label>
									</td>
									<td>
										<input type="text" name="arf_download_url" id="arf_download_url" value="<?php echo esc_attr( $values['arf_download_url'] ); ?>" class="txtstandardnew txtmodal1 arf_digpro_input_width" />
										<div class="arferrmessage" id="arf_download_url_msg arf_display_none">
											<?php esc_html_e( 'This field cannot be blank.', 'ARForms-Digital-Product' ); ?>
										</div>
									</td>
								</tr>

								<tr class="tdclass arf_dig_pro_internal_type_data">
									<td width="18%" valign="top" class="tdclass" >
										<label for="arf_product_image" class="lblsubtitle"><?php esc_html_e( 'Download File', 'ARForms-Digital-Product' ); ?>&nbsp;&nbsp;<span class="arfglobalrequiredfield arf_digpro_valign_top">*</span></label>
									</td>
									<td valign="top" >
										<div id="arf_dig_pro_download_file_data">
											<div class="arf_dig_pro_download_sec">

												<input type="hidden" value="<?php echo esc_html( $values['arf_product_file_url'] ); ?>" name="arf_product_file_hidden"  />

												<input type="hidden" value="<?php echo esc_html( $values['arf_dig_pro_download_type'] ); ?>" name="arf_product_file_type_hidden"  />

												<input type="file" class="arf_digpro_input_file" id="arf_pt_import_file" name="arf_product_file_url"  />
												<label for="arf_pt_import_file">
													<div  class="text pd_input_control pd_input_small helpdesk_txt" id="arf_pt_import_file_input" >
														<div>
															<div id="arf_pt_import_file_name">
															&nbsp;
																<?php
																if ( isset( $values['arf_product_file_url'] ) && ! empty( $values['arf_product_file_url'] ) ) {
																	esc_html_e( 'No file Selected', 'ARForms-Digital-Product' );
																} else {
																	esc_html_e( 'No file Selected', 'ARForms-Digital-Product' );
																}
																?>
															</div>
														</div>

														<div class="arp_import_export_file_btn" >
															<div><?php esc_html_e( 'Add File', 'ARForms-Digital-Product' ); ?></div>
														</div>
													</div>
												</label>

												<?php if ( $arfaction == 'edit' && $values['arf_product_file_url'] ) { ?>
													<small class="arf_dig_pro_download_url">
														<a href="<?php echo $arf_dig_pro_products_class->arf_dig_pro_create_download_link_for_admin( $values['id'] ); ?>"><?php esc_html_e( 'View Download', 'ARForms-Digital-Product' ); ?></a> (<?php echo basename( $values['arf_product_file_url'] ); ?>)
													</small>
												<?php } ?>

											</div>
											<div class="arferrmessage arf_display_none" id="arf_product_file_url_msg " >
												<?php esc_html_e( 'Please upload file.', 'ARForms-Digital-Product' ); ?>
											</div>
										</div>
									</td>
								</tr>

								<tr class="tdclass success_action_message_box success_action_box">
									<td class="tdclass arf_digpro_valign_top" valign="top">
										<label class="lblsubtitle arf_digpro_valign_top"><?php esc_html_e( 'Download Notes', 'ARForms-Digital-Product' ); ?></label>
									</td>
									<td>
										<textarea  name="arf_download_note" cols="50" rows="4" class="arfplacelonginput txtmultinew txtmodal1 arf_digpro_input_width"><?php echo esc_attr( $values['arf_download_note'] ); ?></textarea>
									<td>
								</tr>

								<?php if ( 'edit' == $arfaction && ( ! empty( $product_id ) ) ) { ?>
									<input type='hidden' id='product_id' value='<?php echo esc_html( $product_id ); ?>' />
									<tr>
										<td colspan="2">&nbsp;</td>
									</tr>
									<tr class="tdclass">
										<td valign="top" colspan="2" class="lbltitle titleclass"><br /><?php esc_html_e( 'Download Link Shortcode', 'ARForms-Digital-Product' ); ?></td>
									</tr>
									<tr class="tdclass">
										<td width="18%" class="tdclass" valign="top">
											<label class="lblsubtitle arf_digpro_shortcode_label"><?php esc_html_e( 'Shortcode', 'ARForms-Digital-Product' ); ?></label>
										</td>
										<td>
											<div class="arf_dig_pro_shortcode_sec">
												<span>[ARF_download_link  product_id='<?php echo esc_html( $product_id ); ?>' desc='Download' type='link']</span>
												<p class="howto clear"><?php printf( esc_html__( 'Possible value for type argument %1$s %2$s', 'ARForms-Digital-Product' ), '1) type=\'link\'', '2) type=\'button\'' ); ?></p>
											</div>
										</td>
									</tr>
								<?php } ?>
								<tr>
									<td colspan="2">&nbsp;</td>
								</tr>
							</tbody>
						</table>

						<div class="arf_digpro_product_save_wrapper">
							<button class="arf_btn_dark_blue rounded_button arf_digpro_save_button" id="save_arf_dig_pro" name="save_arf_dig_pro" type="submit" >
								<?php esc_html_e( 'Save', 'ARForms-Digital-Product' ); ?>
							</button>
							<button class="rounded_button arf_digpro_cancel_button" type="button" onclick="location.href = '?page=ARForms-DigitalProduct'">
								<?php esc_html_e( 'Cancel', 'ARForms-Digital-Product' ); ?>
							</button>
							<div class="arf_dig_product_loader"></div>
						</div>
					</form>
				</div>
			</div>
		</div>
	</div>
</div>