<?php
    
if(version_compare($newarformspdfcreator_version, '2.0', '<') ) {

    global $wpdb,$arformspdfcreator,$MdlDb;

    if(file_exists(ABSPATH . 'wp-admin/includes/upgrade.php')) {
            include_once ABSPATH . 'wp-admin/includes/upgrade.php';
    }

    $table_name = $wpdb->prefix . 'arf_pdf_creator';

    $sql = "CREATE TABLE IF NOT EXISTS {$table_name} (
				id int(11) NOT NULL auto_increment,		
				template_name varchar(100) NOT NULL,
				template_content text NOT NULL,
				template_header text NOT NULL,
				template_footer text NOT NULL,
				template_settings text NOT NULL,
				template_header_img text NOT NULL,
				created_at datetime NOT NULL,
				PRIMARY KEY (id)
			  ) {$charset_collate};";

       dbDelta($sql);

       $template_dir = ARF_PDFCREATOR_DIR.'/core/templates';

       $pdf_templates = scandir($template_dir);

       $signature_remove_pattern = '/(\[ARF_Signature\](.*?)\[\/ARF_Signature\])/';

    $pattern_val_in_cond = "/\[ARF_GetValue\:(.*?)\]/";
    $pattern_lab_in_cond = "/\[ARF_GetLabel\:(.*?)\]/";

    $file_name_arr = array();

    if( !function_exists('WP_Filesystem' ) ){
        require_once(ABSPATH . 'wp-admin/includes/file.php');
    }

    WP_Filesystem();
    global $wp_filesystem;

    foreach( $pdf_templates as $templates ){
        if($templates == '.' || $templates == '..' ) {
            continue;
        }
        $file_content = $wp_filesystem->get_contents($template_dir.'/'.$templates);

        $temp_name = explode('.', $templates);
        if(count($temp_name) > 2 ) {
            $template_name = "";
            for($i = 0; $i < count($temp_name) - 1; $i++ ){
                $template_name .= $temp_name[$i].'.';
            }
            $template_name = rtrim($template_name, '.');
        } else {
            $template_name = $temp_name[0];
        }
        $template_name = str_replace('_', ' ', $template_name);

        $content = $file_content;

        preg_match($signature_remove_pattern, $content, $matches);

        $content = isset($matches[0]) ? str_replace($matches[0], '', $content) : $content;

        $content = str_replace("{ARF_IF", "[ARF_IF", $content);
        $content = str_replace("{/ARF_IF}", "[/ARF_IF]", $content);
        $content = preg_replace("/(ARF_IF|ARF_GetLabel|ARF_GetValue|ARF_LOOP)(.*?)\}/", "$1$2]", $content);

        preg_match_all($pattern_val_in_cond, $content, $mat);

        $content = preg_replace($pattern_val_in_cond, '{ARF_GetValue:$1}', $content);
        $content = preg_replace($pattern_lab_in_cond, '{ARF_GetLabel:$1}', $content);

        $content = preg_replace("/\[VAR (.*?)\]/", "{VAR $1}", $content);

        $content = str_replace("[ARF_GetEntryID]", "{ARF_GetEntryID}", $content);

        $template_array = array();
        $template_header = array(
        'left' => '',
        'center' => '{ARF_FormTitle}',
        'right' => ''
        );
        $template_footer = array(
        'left' => '',
        'center' => '',
        'right' => ''
        );
        $template_settings = array(
        'arf_pdf_template_size' => 'A4',
        'arf_pdf_template_orientation' => 'portrait',
        'arf_pdf_template_font' => 'Arial',
        'arf_pdf_pgno' => 1
        );
        $template_header_img = array(
        'pdf_header_img_name' => '',
        'pdf_header_img_align' => 'center'
        );

        $content = str_replace("<?php echo ARF_PDFCREATOR_URL.'/css/arformspdfcreator.css';?>", ARF_PDFCREATOR_URL.'/css/arformspdfcreator.css', $content);
        $content = str_replace('<?php echo ARF_PDFCREATOR_URL."/css/arformspdfcreator.css";?>', ARF_PDFCREATOR_URL.'/css/arformspdfcreator.css', $content);

        $template_array['template_name'] = $template_name;
        $template_array['template_header'] = maybe_serialize($template_header);
        $template_array['template_footer'] = maybe_serialize($template_footer);
        $template_array['template_settings'] = maybe_serialize($template_settings);
        $template_array['template_header_img'] = maybe_serialize($template_header_img);
        $template_array['template_content'] = $content;
        $template_array['created_at'] = current_time('mysql');

        $wpdb->insert($arformspdfcreator->db_pdf_creator, $template_array, array('%s','%s','%s','%s','%s','%s','%s'));

        $file_name_arr[$templates] = $wpdb->insert_id;
    }

       $form_opts = $wpdb->get_results($wpdb->prepare("SELECT id,options FROM `".$MdlDb->forms."` WHERE is_template = %d AND status = %s", 0, 'published'));

    foreach( $form_opts as $k => $form_opt ){

         $form_id = $form_opt->id;
         $options = maybe_unserialize($form_opt->options);

        if(isset($options['arf_pdf_template']) && $options['arf_pdf_template'] != '' ) {
            $pdf_file_name = $options['arf_pdf_template'];

            $template_id = isset($file_name_arr[$pdf_file_name]) ? $file_name_arr[$pdf_file_name] : 1;

            $options['arf_pdf_template'] = $template_id;
        }

         $wpdb->update($MdlDb->forms, array('options' => maybe_serialize($options) ), array('id' => $form_id));

    }

}

if( version_compare($newarformspdfcreator_version, '2.7', '<') ){
    update_option( 'arf_pdfcreator_font_notice', 'yes' );
}

if( version_compare( $newarformspdfcreator_version, '2.9', '<') ){
    global $wpdb,$arformspdfcreator;
    $wpdb->query("ALTER TABLE `".$arformspdfcreator->db_pdf_creator."` CHANGE `template_content` `template_content` LONGTEXT");
}

if( version_compare( $newarformspdfcreator_version, '3.5', '<') ) {
    global $arformspdfcreator, $wpdb;
    $update_font_notice = false;

    if( false == $update_font_notice ){
        $table_name = $wpdb->prefix . 'arf_pdf_creator';

        $get_settings = $wpdb->get_results( "SELECT id,template_settings FROM `" . $table_name . "` ORDER BY id DESC" );

        $font_lists = $arformspdfcreator->arforms_pdf_get_fonts_arr();

        if( !empty( $get_settings ) ){
            foreach( $get_settings as $temp_obj ){
                $template_id = $temp_obj->id;
                $temp_settings = maybe_unserialize( $temp_obj->template_settings );

                $font_family = $temp_settings['arf_pdf_template_font'];

                if( !empty( $font_lists[ $font_family ] ) ){
                    $update_font_notice = true;
                    break;
                }

            }
        }
    }

    if( $update_font_notice ){
        update_option( 'arf_pdfcreator_font_notice', 'yes' );
    }
}

if( version_compare( $newarformspdfcreator_version, '3.6', '<' ) ){

    global $arformspdfcreator, $wpdb;

    $wp_upload_dir = wp_upload_dir();

    $upload_dir = $wp_upload_dir['basedir'] . '/arformspdfcreator';
    $upload_url = $wp_upload_dir['baseurl'] . '/arformspdfcreator';

    wp_mkdir_p( $upload_dir );

    $arfpdf_font_dir = $upload_dir.'/fonts';

    wp_mkdir_p( $arfpdf_font_dir );

    $source_dir = ARF_PDFCREATOR_DIR . '/libs/vendor/mpdf/mpdf/ttfonts';
    $destination_dir = $arfpdf_font_dir;

    if( !is_dir( $destination_dir ) ){
        wp_mkdir_p( $destination_dir );
    }

    if( is_dir( $source_dir ) ){
        if( $dh = opendir( $source_dir ) ){
            while( ($file = readdir($dh)) !== false ){
                if( '.' != $file && '..' != $file ){
                    $source = $source_dir.'/'.$file;
                    $target = $destination_dir . '/' .$file;
                    try{
                        copy( $source, $target );
                    } catch(Exception $e){
                        update_option( 'arf_pdfcreator_font_notice', 'yes' );
                    }
                }
            }
        }
    }

    $font_lists = $arformspdfcreator->arforms_pdf_get_fonts_arr();

    $arfpdf_copy_extra_fonts = false;

    if( false == $arfpdf_copy_extra_fonts ){
        $table_name = $wpdb->prefix . 'arf_pdf_creator';

        $get_settings = $wpdb->get_results( "SELECT id,template_settings FROM `" . $table_name . "` ORDER BY id DESC" );


        if( !empty( $get_settings ) ){
            foreach( $get_settings as $temp_obj ){
                $template_id = $temp_obj->id;
                $temp_settings = maybe_unserialize( $temp_obj->template_settings );

                $font_family = $temp_settings['arf_pdf_template_font'];

                if( !empty( $font_lists[ $font_family ] ) ){
                    $arfpdf_copy_extra_fonts = true;
                    break;
                }

            }
        }
    }

    if( $arfpdf_copy_extra_fonts ){

        $font_list                  = $arformspdfcreator->arforms_pdf_get_fonts_arr();
        $child_font                 = true;
        foreach ( $font_list as $fontkey => $font_val ) {
            foreach ( $font_val as $font_files ) {
                foreach ( $font_files as $font ) {
                    $destination = ARFPDFCREATOR_FONT_DIR . '/' . $font;
                    $source      = 'https://www.arformsplugin.com/arf_pdfcreator_fonts/?action=arf_pdf_import_form&font=' . $font;

                    $args = array(
                        'timeout' => 50,
                    );

                    $response = wp_remote_get( $source, $args );

                    if ( !is_wp_error($response) && isset( $response['body'] ) && $response['body'] != '' ) {
                        WP_Filesystem();
                        global $wp_filesystem;
                        $newfile = wp_remote_retrieve_body( $response );
                        
                        if ( !empty($newfile) ) {
                            if( !file_exists( $destination ) ){
                                $fh = fopen( $destination, 'wb' );
                                fclose( $fh );
                            }
                            $isWrite = $wp_filesystem->put_contents($destination, $newfile);
                            if( !$isWrite ){
                                update_option( 'arf_pdfcreator_font_notice', 'yes' );
                            }
                        } else {
                            update_option( 'arf_pdfcreator_font_notice', 'yes' );
                        }
                    } else {
                        update_option( 'arf_pdfcreator_font_notice', 'yes' );
                    }
                }
            }
        }
    }
}

if( version_compare( 'arformspdfcreator_version', '3.8', '<' ) ){


    $source_dir = ARF_PDFCREATOR_DIR . '/libs/vendor/mpdf/mpdf/ttfonts';
    $destination_dir = ARFPDFCREATOR_FONT_DIR;

    $file = 'DejaVuSansMono-Bold.ttf';

    $source = $source_dir.'/'.$file;
    $target = $destination_dir . '/' .$file;

    try{
        copy( $source, $target );
    } catch(Exception $e){
        //destination directory does not have permission
    }

}


update_option('arformspdfcreator_version', '4.1');

global $newarformspdfcreator_version;
$newarformspdfcreator_version = '4.1';

update_option( 'arf_pdfcreator_updated_date_' . $newarformspdfcreator_version, current_time('mysql') );
