<?php
global $wpdb, $db_record, $maincontroller;

$actions = array( '-1' => addslashes( esc_html__( 'Bulk Actions', 'ARForms-postcreator' ) ),
                  'bulk_delete' => addslashes(esc_html__('Delete', 'ARForms-postcreator')) );

echo str_replace( 'id="{arf_id}"', 'id="arf_full_width_loader"', ARF_LOADER_ICON );


$error_msg = '';
if ( isset( $_REQUEST['err'] ) && $_REQUEST['err'] ) {
	$error_msg = esc_html__( 'This form is already deleted', 'ARForms-postcreator' );
}

?>

<div id="success_message" class="arf_success_message">
	<div class="message_descripiton">
		<div id="success_msg_text"></div>
		<div class="message_svg_icon">
			<svg height="14px" stroke-width="14px">
				<path fill-rule="evenodd" clip-rule="evenodd" fill="#FFFFFF" d="M6.075,14.407l-5.852-5.84l1.616-1.613l4.394,4.385L17.181,0.411 l1.616,1.613L6.392,14.407H6.075z"></path>
			</svg>
		</div>
	</div>
</div>

<div id="error_message" class="arf_error_message">
	<div class="message_descripiton">
		<div id="error_msg_text" ></div>
		<div class="message_svg_icon">
			<svg height="14px" stroke-width="14px">
				<path fill-rule="evenodd" clip-rule="evenodd" fill="#ffffff" d="M10.702,10.909L6.453,6.66l-4.249,4.249L1.143,9.848l4.249-4.249L1.154,1.361l1.062-1.061l4.237,4.237l4.238-4.237l1.061,1.061L7.513,5.599l4.249,4.249L10.702,10.909z"></path>
			</svg>
		</div>
	</div>
</div>

<div class="wrap postcreator_page">
	<div class="top_bar">
	<span class="h2"><?php esc_html_e( 'Post Creator Configuration', 'ARForms-postcreator' ); ?></span>
	</div>
	<div id="poststuff" class="metabox-holder">
		<div id="post-body">
			<div class="inside">
				<div class="frm_settings_form wrap_content">
					<form name="arf_postcreator_forms" method="get" id="arf_postcreator_forms" onsubmit="return arf_postcreator_form_bulk_act();">
						<div id="arf_postcreator_forms" class='arf_postcreator_list_form'>

							<div class="arf_newaction_rounded_blue_button">
								<button class="rounded_button arf_pc_add_new_btn arf_btn_dark_blue" type="button" onclick="location.href = '<?php echo admin_url( 'admin.php?page=ARForms-postcreator&arfaction=new' ); ?>';" >
									<svg width="20px" height="20px" class="arf_pc_valign_middle" >
										<path  fill-rule="evenodd" clip-rule="evenodd" fill="#FFFFFF" d="M16.997,7.32v2h-7v6.969h-2V9.32h-7v-2h7V0.289h2V7.32H16.997z"></path>
									</svg>
									&nbsp;&nbsp;<?php esc_html_e( 'Configure New Form', 'ARForms-postcreator' ); ?>
								</button>
							</div>

							<div class="alignleft actions">
				<div class="arf_list_bulk_action_wrapper">
					<?php
					$li_content = '';
						foreach ( $actions as $name => $title ) {
							$class = 'edit' == $name ? ' class="hide-if-no-js" ' : '';
						$li_content .= '<li '.$class .' data-value="'. $name .'"  data-label="'. $title .'" >'. $title .' </li>';
						$li_class_form_arr[$name] = $title;
					}
					if( method_exists( $maincontroller, 'arf_selectpicker_dom') ){
						echo $maincontroller->arf_selectpicker_dom( 'action1', 'arf_bulk_action_one', ' arf_selectbox', '', '', array(), $li_class_form_arr );
					} else { 
						?>
					<input id="arf_bulk_action_one" name="action1" value="-1" type="hidden">
					<dl class="arf_selectbox" data-name="action1" data-id="arf_bulk_action_one">
					<dt class="arf_bulkact_list"><span><?php echo esc_html__( 'Bulk Actions', 'ARForms-postcreator' ); ?></span>
					<svg viewBox="0 0 2000 1000" width="15px" height="15px">
					<g fill="#000">
						<path d="M1024 320q0 -26 -19 -45t-45 -19h-896q-26 0 -45 19t-19 45t19 45l448 448q19 19 45 19t45 -19l448 -448q19 -19 19 -45z"/>
					</g>
					</svg>
					</dt>
					<dd>
					<ul data-id="arf_bulk_action_one">
						<li data-value='-1' data-label='<?php esc_html_e( 'Bulk Actions', 'ARForms-postcreator' ); ?>'><?php esc_html_e( 'Bulk Actions', 'ARForms-postcreator' ); ?></li>
						
					</ul>
					</dd>
					</dl>
				<?php } ?>
				</div>
				<input type="submit" id="doaction1" class="arf_bulk_action_btn rounded_button btn_green " value="<?php echo esc_html__( 'Apply', 'ARForms-postcreator' ); ?>" />
							</div>
							<table cellpadding="0" cellspacing="0" border="0" class="display table_grid" id="example">
								<thead>
									<tr>
										<th class="center arf_chkbox_all_select">
										<div class="arf_custom_checkbox_div">
											<div class="arf_custom_checkbox_wrapper arf_all_checkbox_margin" >
												<input id="cb-select-all-1" type="checkbox" class="">
												<svg width="18px" height="18px">
												<?php echo ARF_CUSTOM_UNCHECKED_ICON; ?>
												<?php echo ARF_CUSTOM_CHECKED_ICON; ?>
												</svg>
											</div>
										
										<label for="cb-select-all-1"  class="cb-select-all"><span></span></label> </div></th>
								<th class=""><?php esc_html_e( 'Form ID', 'ARForms-postcreator' ); ?></th>
								<th class=""><?php esc_html_e( 'Form Title', 'ARForms-postcreator' ); ?></th>
								<th class=""><?php esc_html_e( 'Entries', 'ARForms-postcreator' ); ?></th>
								<th class=""><?php esc_html_e( 'Mapped with', 'ARForms-postcreator' ); ?></th>
								<th class=""><?php esc_html_e( 'Created Date', 'ARForms-postcreator' ); ?></th>
								<th class="arf_col_action arf_action_cell"><?php esc_html_e( 'Action', 'ARForms-postcreator' ); ?></th>
								</tr>
								</thead>
								</tbody>
								<?php
								global $arf_version, $MdlDb, $arformcontroller, $arfform;
								if( version_compare( $arf_version, '5.0', '<=' ) ){
									if( version_compare( $arf_version, '4.3', '<' ) ){

										$forms = $wpdb->get_results( 'SELECT pc.*,count(ent.id) AS counter FROM ' . $wpdb->prefix . 'arf_postcreator_forms pc LEFT OUTER JOIN ' . $MdlDb->entries . ' ent ON ent.form_id = pc.form_id GROUP BY pc.form_id ORDER BY pc.form_id DESC ');

									}else{

										$tblnm = $wpdb->prefix . 'arf_postcreator_forms pc LEFT OUTER JOIN ' . $MdlDb->entries . ' ent ON ent.form_id = pc.form_id LEFT JOIN ' . $MdlDb->forms . ' frm ON pc.form_id = frm.id';

										$forms = $arfform->arf_select_db_data(true, '', $tblnm , 'pc.*,count(ent.id) AS counter', '', array(), 'GROUP BY pc.form_id','ORDER BY pc.form_id DESC');
										
									}

									if ( count( $forms ) > 0 ) {
										foreach ( $forms as $form ) {
											$options = maybe_unserialize( $form->options );
											?>
											<tr class="arf_pc_form_list_row">
												<td class="center">
												<div class="arf_custom_checkbox_div arfmarginl15">
												<div class="arf_custom_checkbox_wrapper">
													<input id="cb-item-action-<?php echo esc_html( $form->id ); ?>" class="" type="checkbox" value="<?php echo esc_html( $form->id ); ?>" name="item-action[]">
													<svg width="18px" height="18px">
													<?php echo ARF_CUSTOM_UNCHECKED_ICON; ?>
													<?php echo ARF_CUSTOM_CHECKED_ICON; ?>
													</svg>
												</div>
												</div>

												<label for="cb-item-action-<?php echo esc_html( $form->id ); ?>"><span></span></label></td>
												<td><?php echo esc_html( $form->form_id ); ?></td>
												<td class="form_name"><a class="row-title" href="<?php echo wp_nonce_url( "?page=ARForms-postcreator&arfaction=edit&id={$form->id}" ); ?>"> <?php echo $form->form_name; ?></a></td>
												<td class="form_entries center">
													<?php

													echo ( current_user_can( 'arfviewentries' ) ) ? '<a href="' . esc_url( admin_url( 'admin.php' ) . '?page=ARForms-entries&form=' . $form->form_id ) . '">' . $form->counter . '</a>' : $form->counter;
													?>
												</td>
												<td><?php 
													if ($options['post_type'] == 'custom') {
														echo ucfirst( $options['post_type'] ) . ' (' . $options['custom_post'] . ') Post';
													}else if ($options['post_type'] == 'buddypress_grp') {
														echo 'BuddyPress Group Post';
													}else{
														echo ucfirst( $options['post_type'] ) . ' Post';
													}?> 	
												</td>
												<td><?php echo date( get_option( 'date_format' ), strtotime( $form->created_at ) ); ?></td>
											<td class="arf_action_cell">
												<div class="arf-row-actions arf_pc_no_padding_top">
											<?php
													$edit_link = "?page=ARForms-postcreator&arfaction=edit&id={$form->id}";

													echo "<div class='arfformicondiv arfhelptip' title='" . esc_html__( 'Edit Configuration', 'ARForms-postcreator' ) . "'><a href='" . wp_nonce_url( $edit_link ) . "'><svg width='30px' height='30px' viewBox='-5 -4 30 30' class='arfsvgposition'><path fill='#ffffff' d='M17.469,7.115v10.484c0,1.25-1.014,2.264-2.264,2.264H3.75c-1.25,0-2.262-1.014-2.262-2.264V5.082  c0-1.25,1.012-2.264,2.262-2.264h9.518l-2.264,2.001H3.489v13.042h11.979V9.379L17.469,7.115z M15.532,2.451l-0.801,0.8l2.4,2.401  l0.801-0.8L15.532,2.451z M17.131,0.85l-0.799,0.801l2.4,2.4l0.801-0.801L17.131,0.85z M6.731,11.254l2.4,2.4l7.201-7.202  l-2.4-2.401L6.731,11.254z M5.952,14.431h2.264l-2.264-2.264V14.431z'></path></svg></a></div>";


													echo "<div class='arfformicondiv arfhelptip arfdeleteform_div_" . $form->id . "' title='" . esc_html__( 'Delete', 'ARForms-postcreator' ) . "'><a class='arf_post_creator_delete' data-id='" . $form->id . "' ><svg width='30px' height='30px' viewBox='-5 -5 32 32' class='arfsvgposition'><path fill-rule='evenodd' clip-rule='evenodd' fill='#ffffff' d='M18.435,4.857L18.413,19.87L3.398,19.88L3.394,4.857H1.489V2.929  h1.601h3.394V0.85h8.921v2.079h3.336h1.601l0,0v1.928H18.435z M15.231,4.857H6.597H5.425l0.012,13.018h10.945l0.005-13.018H15.231z   M11.4,6.845h2.029v9.065H11.4V6.845z M8.399,6.845h2.03v9.065h-2.03V6.845z' /></svg></a></div>";

											?>
												</div>
												</td>
											</tr>
											<?php
										}
									}

								}
								?>
								</tbody>
							</table>
							<div class="clear"></div>
							<input type="hidden" name="show_hide_columns" id="show_hide_columns" value="<?php esc_html_e( 'Show / Hide columns', 'ARForms-postcreator' ); ?>"/>
							<input type="hidden" name="search_grid" id="search_grid" value="<?php esc_html_e( 'Search', 'ARForms-postcreator' ); ?>"/>
							<input type="hidden" name="entries_grid" id="entries_grid" value="<?php esc_html_e( 'entries', 'ARForms-postcreator' ); ?>"/>
							<input type="hidden" name="show_grid" id="show_grid" value="<?php esc_html_e( 'Show', 'ARForms-postcreator' ); ?>"/>
							<input type="hidden" name="showing_grid" id="showing_grid" value="<?php esc_html_e( 'Showing', 'ARForms-postcreator' ); ?>"/>
							<input type="hidden" name="to_grid" id="to_grid" value="<?php esc_html_e( 'to', 'ARForms-postcreator' ); ?>"/>
							<input type="hidden" name="of_grid" id="of_grid" value="<?php esc_html_e( 'of', 'ARForms-postcreator' ); ?>"/>
							<input type="hidden" name="no_match_record_grid" id="no_match_record_grid" value="<?php esc_html_e( 'No matching records found', 'ARForms-postcreator' ); ?>"/>
							<input type="hidden" name="no_record_grid" id="no_record_grid" value="<?php esc_html_e( 'No data available in table', 'ARForms-postcreator' ); ?>"/>
							<input type="hidden" name="filter_grid" id="filter_grid" value="<?php esc_html_e( 'filtered from', 'ARForms-postcreator' ); ?>"/>
							<input type="hidden" name="totalwd_grid" id="totalwd_grid" value="<?php esc_html_e( 'total', 'ARForms-postcreator' ); ?>"/>

							<div class="alignleft actions2">
				<div class="arf_list_bulk_action_wrapper">
					<?php
			    	$li_content = '';
					foreach ($actions as $name => $title) {
					$class = 'edit' == $name ? ' class="hide-if-no-js" ' : '';
					$li_content .= '<li '.$class .' data-value="'. $name .'"  data-label="'. $title .'" >'. $title .' </li>';
					$li_class_form_arr[$name] = $title;
					}

					if( method_exists( $maincontroller, 'arf_selectpicker_dom') ){
						echo $maincontroller->arf_selectpicker_dom( 'action3', 'arf_bulk_action_two', ' arf_selectbox', '', '' , array(), $li_class_form_arr );
					} else {

					?>

					<input id="arf_bulk_action_two" name="action3" value="-1" type="hidden">
					<dl class="arf_selectbox" data-name="action3" data-id="arf_bulk_action_two">
					<dt class='arf_bulkact_list'><span><?php echo esc_html__( 'Bulk Actions', 'ARForms-postcreator' ); ?></span>
					<svg viewBox="0 0 2000 1000" width="15px" height="15px">
					<g fill="#000">
						<path d="M1024 320q0 -26 -19 -45t-45 -19h-896q-26 0 -45 19t-19 45t19 45l448 448q19 19 45 19t45 -19l448 -448q19 -19 19 -45z"/>
					</g>
					</svg>
					</dt>
					<dd>
					<ul data-id="arf_bulk_action_two">
						<li data-value='-1' data-label='<?php esc_html_e( 'Bulk Actions', 'ARForms-postcreator' ); ?>'><?php esc_html_e( 'Bulk Actions', 'ARForms-postcreator' ); ?></li>
						<?php echo $li_content;?>
					</ul>
					</dd>
					</dl>
				<?php } ?>
				</div>
				<input type="submit" id="doaction3" class="arf_bulk_action_btn rounded_button btn_green" value="<?php echo esc_html__( 'Apply', 'ARForms-postcreator' ); ?>" />
							</div>
							<div class="footer_grid"></div>

						</div>
						</form>

				</div>

				<div class="documentation_link" align="right">
					<a href="<?php echo ARF_POSTCREATOR_URL; ?>/documentation/index.html" target="_blank" class="arlinks"><?php esc_html_e( 'Post Creator Documentation', 'ARForms-postcreator' ); ?></a>|<a href="https://helpdesk.arpluginshop.com/submit-a-ticket/" target="_blank" class="arlinks"><?php esc_html_e( 'Support', 'ARForms-postcreator' ); ?></a> &nbsp;&nbsp;<img src="<?php echo ARFURL; ?>/images/dot.png" height="4" width="4" onclick="javascript:OpenInNewTab('<?php echo ARFURL; ?>/documentation/assets/sysinfo.php');" /></div>

			</div>
		</div>
	</div>

	<div class="arf_modal_overlay">
    <div id="delete_bulk_postcreator_form_message" class="arfdeletemodabox arfmodal arf_popup_container arfdeletemodalboxnew">
        <input type="hidden" value="false" id="delete_bulk_entry_flag"/>
        
        <div class="arfdelete_modal_msg delete_confirm_message"><?php echo addslashes(sprintf(esc_html__('Are you sure you want to %s delete selected Form(s)?','ARForms-postcreator'),'<br/>')); ?></div>
        <div class="arf_delete_modal_row delete_popup_footer">
            <button class="rounded_button add_button arf_delete_modal_left arfdelete_color_red" onclick="arf_delete_bulk_postcreator_form('true');">&nbsp;<?php echo addslashes(esc_html__('Okay', 'ARForms-postcreator')); ?></button>&nbsp;&nbsp;<button class="arf_delete_modal_right rounded_button delete_button arfdelete_color_gray arf_bulk_delete_transaction_close_btn" data-dismiss="arfmodal">&nbsp;<?php echo addslashes(esc_html__('Cancel', 'ARForms-postcreator')); ?></button>
        </div>
    </div>
</div>
